import { useState } from 'react';
import { unstable_useSealedState } from '../utils/useSealedState.js';

/**
 * As simple as `React.useState(false)`
 */
function useCheckboxState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _unstable_useSealedSt = unstable_useSealedState(initialState),
      _unstable_useSealedSt2 = _unstable_useSealedSt.state,
      initialValue = _unstable_useSealedSt2 === void 0 ? false : _unstable_useSealedSt2;

  var _React$useState = useState(initialValue),
      state = _React$useState[0],
      setState = _React$useState[1];

  return {
    state: state,
    setState: setState
  };
}
var keys = ["state", "setState"];
useCheckboxState.__keys = keys;

export { useCheckboxState };
