import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../Hidden/HiddenState.js';
import { useHidden } from '../Hidden/Hidden.js';
import { useDialogState } from './DialogState.js';

var useDialogBackdrop = unstable_createHook({
  name: "DialogBackdrop",
  compose: useHidden,
  useState: useDialogState,
  useProps: function useProps(_, htmlProps) {
    return unstable_mergeProps({
      id: undefined,
      role: "presentation",
      style: {
        position: "fixed",
        top: 0,
        right: 0,
        bottom: 0,
        left: 0,
        zIndex: 998
      }
    }, htmlProps);
  }
});
var DialogBackdrop = unstable_createComponent({
  as: "div",
  useHook: useDialogBackdrop
});

export { DialogBackdrop, useDialogBackdrop };
