import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { unstable_useProps } from '../system/useProps.js';
import '../chunk-2f16e450.js';
import '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import { useTabbable } from '../Tabbable/Tabbable.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import { unstable_getIn } from './utils/getIn.js';
import './utils/setIn.js';
import { a as formatInputName } from '../chunk-062e44ee.js';
import { a as getInputId } from '../chunk-e6fae15a.js';
import { a as getLabelId } from '../chunk-48c13397.js';
import { b as getMessageId, a as shouldShowError } from '../chunk-e2383517.js';

var defaultClickKeys = [];
function unstable_useFormInput(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("FormInput", options, htmlProps);
  htmlProps = unstable_mergeProps({
    id: getInputId(options.name, options.baseId),
    name: formatInputName(options.name),
    value: unstable_getIn(options.values, options.name, ""),
    onChange: function onChange(event) {
      return options.update(options.name, event.target.value);
    },
    onBlur: function onBlur() {
      return options.blur(options.name);
    },
    "aria-describedby": getMessageId(options.name, options.baseId),
    "aria-labelledby": getLabelId(options.name, options.baseId),
    "aria-invalid": shouldShowError(options, options.name)
  }, htmlProps);
  htmlProps = unstable_useProps("FormInput", options, htmlProps);
  htmlProps = useTabbable(_objectSpread({}, options, {
    unstable_clickKeys: defaultClickKeys
  }), htmlProps);
  return htmlProps;
}
var keys = [].concat(useTabbable.__keys, unstable_useFormState.__keys, ["name"]);
unstable_useFormInput.__keys = keys;
var unstable_FormInput = unstable_createComponent({
  as: "input",
  useHook: unstable_useFormInput
});

export { unstable_FormInput, unstable_useFormInput };
