import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { unstable_useProps } from '../system/useProps.js';
import '../chunk-2f16e450.js';
import '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import './utils/getIn.js';
import './utils/setIn.js';
import '../chunk-062e44ee.js';
import { a as getInputId } from '../chunk-e6fae15a.js';
import { a as getLabelId } from '../chunk-48c13397.js';

function unstable_useFormLabel(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("FormLabel", options, htmlProps);
  htmlProps = unstable_mergeProps({
    children: options.label,
    id: getLabelId(options.name, options.baseId),
    htmlFor: getInputId(options.name, options.baseId)
  }, htmlProps);
  htmlProps = unstable_useProps("FormLabel", options, htmlProps);
  htmlProps = useBox(options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, unstable_useFormState.__keys, ["name", "label"]);
unstable_useFormLabel.__keys = keys;
var unstable_FormLabel = unstable_createComponent({
  as: "label",
  useHook: unstable_useFormLabel
});

export { unstable_FormLabel, unstable_useFormLabel };
