import { useContext } from 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { unstable_useProps } from '../system/useProps.js';
import '../chunk-2f16e450.js';
import '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-e555b6ea.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import { unstable_getIn } from './utils/getIn.js';
import './utils/setIn.js';
import { a as formatInputName } from '../chunk-062e44ee.js';
import '../chunk-e6fae15a.js';
import '../chunk-48c13397.js';
import '../chunk-e2383517.js';
import '../Group/Group.js';
import './FormGroup.js';
import '../chunk-96f01ae3.js';
import '../Rover/RoverState.js';
import '../Rover/Rover.js';
import '../Radio/RadioState.js';
import { useRadio } from '../Radio/Radio.js';
import { FormRadioGroupContext } from './FormRadioGroup.js';

function unstable_useFormRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("FormRadio", options, htmlProps);
  var rover = useContext(FormRadioGroupContext);

  if (!rover) {
    // TODO: Better error
    throw new Error("Missing FormRadioGroup");
  }

  var currentChecked = unstable_getIn(options.values, options.name);
  var checked = currentChecked === options.value;

  var allOptions = _objectSpread({}, rover, options, {
    checked: checked
  });

  htmlProps = unstable_mergeProps({
    name: formatInputName(options.name),
    onChange: function onChange() {
      return options.update(options.name, options.value);
    },
    onBlur: function onBlur() {
      return options.blur(options.name);
    },
    onFocus: function onFocus() {
      return options.update(options.name, options.value);
    }
  }, htmlProps);
  htmlProps = unstable_useProps("FormRadio", allOptions, htmlProps);
  htmlProps = useRadio(allOptions, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, unstable_useFormState.__keys, ["name", "value"]);
unstable_useFormRadio.__keys = keys;
var unstable_FormRadio = unstable_createComponent({
  as: "input",
  useHook: unstable_useFormRadio
});

export { unstable_FormRadio, unstable_useFormRadio };
