import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { unstable_useProps } from '../system/useProps.js';
import '../chunk-2f16e450.js';
import '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { useButton } from '../Button/Button.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import './utils/getIn.js';
import './utils/setIn.js';

function getFirstInvalidInput(baseId) {
  var selector = "[aria-invalid=true][id^=" + baseId + "]";
  return document.querySelector(selector);
}

function unstable_useFormSubmitButton(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("FormSubmitButton", options, htmlProps);
  htmlProps = unstable_mergeProps({
    type: "submit",
    disabled: options.submitting,
    onClick: function onClick() {
      window.requestAnimationFrame(function () {
        var input = getFirstInvalidInput(options.baseId);

        if (input) {
          input.select();
          input.focus();
        }
      });
    }
  }, htmlProps);
  htmlProps = unstable_useProps("FormSubmitButton", options, htmlProps);
  htmlProps = useButton(options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useButton.__keys, unstable_useFormState.__keys);
unstable_useFormSubmitButton.__keys = keys;
var unstable_FormSubmitButton = unstable_createComponent({
  as: "button",
  useHook: unstable_useFormSubmitButton
});

export { unstable_FormSubmitButton, unstable_useFormSubmitButton };
