import { useState, useEffect, useCallback } from 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';
import { useHiddenState } from './HiddenState.js';

var useHidden = unstable_createHook({
  name: "Hidden",
  compose: useBox,
  useState: useHiddenState,
  keys: ["unstable_animated"],
  useProps: function useProps(options, htmlProps) {
    var _React$useState = useState(options.visible),
        delayedVisible = _React$useState[0],
        setDelayedVisible = _React$useState[1];

    useEffect(function () {
      if (options.unstable_animated && options.visible) {
        setDelayedVisible(options.visible);
      }
    }, [options.visible, options.unstable_animated]);
    var onTransitionEnd = useCallback(function () {
      if (options.unstable_animated && !options.visible) {
        setDelayedVisible(options.visible);
      }
    }, [options.visible, options.unstable_animated]); // delays hiding

    var hidden = options.unstable_animated ? options.visible ? false : !delayedVisible : !options.visible; // delays showing

    var shouldAddHiddenClass = options.unstable_animated ? options.visible ? !delayedVisible : true : !options.visible;
    return unstable_mergeProps({
      role: "region",
      id: options.unstable_hiddenId,
      className: shouldAddHiddenClass ? "hidden" : undefined,
      hidden: hidden,
      onTransitionEnd: onTransitionEnd
    }, htmlProps);
  }
});
var Hidden = unstable_createComponent({
  as: "div",
  useHook: useHidden
});

export { Hidden, useHidden };
