import { useState, useCallback } from 'react';
import { unstable_useSealedState } from '../utils/useSealedState.js';
import { unstable_useId } from '../utils/useId.js';

function useHiddenState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _unstable_useSealedSt = unstable_useSealedState(initialState),
      _unstable_useSealedSt2 = _unstable_useSealedSt.unstable_hiddenId,
      hiddenId = _unstable_useSealedSt2 === void 0 ? unstable_useId("hidden-") : _unstable_useSealedSt2,
      _unstable_useSealedSt3 = _unstable_useSealedSt.visible,
      sealedVisible = _unstable_useSealedSt3 === void 0 ? false : _unstable_useSealedSt3;

  var _React$useState = useState(sealedVisible),
      visible = _React$useState[0],
      setVisible = _React$useState[1];

  var show = useCallback(function () {
    return setVisible(true);
  }, []);
  var hide = useCallback(function () {
    return setVisible(false);
  }, []);
  var toggle = useCallback(function () {
    return setVisible(function (v) {
      return !v;
    });
  }, []);
  return {
    unstable_hiddenId: hiddenId,
    visible: visible,
    show: show,
    hide: hide,
    toggle: toggle
  };
}
var keys = ["unstable_hiddenId", "visible", "show", "hide", "toggle"];
useHiddenState.__keys = keys;

export { useHiddenState };
