import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { b as _objectWithoutPropertiesLoose, a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../chunk-29332083.js';
import { a as warning } from '../chunk-e555b6ea.js';
import 'react-dom';
import '../Portal/Portal.js';
import '../Hidden/HiddenState.js';
import '../Hidden/Hidden.js';
import { useDialog } from '../Dialog/Dialog.js';
import 'body-scroll-lock';
import '../chunk-b4d83ecc.js';
import '../Dialog/DialogState.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

var usePopover = unstable_createHook({
  name: "Popover",
  compose: useDialog,
  useState: usePopoverState,
  useOptions: function useOptions(_ref) {
    var _ref$modal = _ref.modal,
        modal = _ref$modal === void 0 ? false : _ref$modal,
        options = _objectWithoutPropertiesLoose(_ref, ["modal"]);

    return _objectSpread({
      modal: modal
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    return unstable_mergeProps({
      ref: options.unstable_popoverRef,
      style: options.unstable_popoverStyles
    }, htmlProps);
  }
});
var Popover = unstable_createComponent({
  as: "div",
  useHook: usePopover,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/popover", "Popover") : void 0;
    return unstable_useCreateElement(type, props, children);
  }
});

export { Popover, usePopover };
