import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../system/SystemProvider.js';
import '../utils/Provider.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../Button/Button.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import '../Hidden/HiddenDisclosure.js';
import { useDialogDisclosure } from '../Dialog/DialogDisclosure.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

var usePopoverDisclosure = unstable_createHook({
  name: "PopoverDisclosure",
  compose: useDialogDisclosure,
  useState: usePopoverState,
  useProps: function useProps(options, htmlProps) {
    return unstable_mergeProps({
      ref: options.unstable_referenceRef
    }, htmlProps);
  }
});
var PopoverDisclosure = unstable_createComponent({
  as: "button",
  useHook: usePopoverDisclosure
});

export { PopoverDisclosure, usePopoverDisclosure };
