import { useRef, useState, useLayoutEffect, useCallback } from 'react';
import { unstable_useSealedState } from '../utils/useSealedState.js';
import '../utils/useId.js';
import { b as _objectWithoutPropertiesLoose, a as _objectSpread } from '../chunk-adf96f9e.js';
import '../Hidden/HiddenState.js';
import { useDialogState } from '../Dialog/DialogState.js';
import Popper from 'popper.js';

function usePopoverState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _unstable_useSealedSt = unstable_useSealedState(initialState),
      _unstable_useSealedSt2 = _unstable_useSealedSt.placement,
      sealedPlacement = _unstable_useSealedSt2 === void 0 ? "bottom" : _unstable_useSealedSt2,
      _unstable_useSealedSt3 = _unstable_useSealedSt.unstable_flip,
      flip = _unstable_useSealedSt3 === void 0 ? true : _unstable_useSealedSt3,
      _unstable_useSealedSt4 = _unstable_useSealedSt.unstable_shift,
      shift = _unstable_useSealedSt4 === void 0 ? true : _unstable_useSealedSt4,
      _unstable_useSealedSt5 = _unstable_useSealedSt.unstable_gutter,
      gutter = _unstable_useSealedSt5 === void 0 ? 12 : _unstable_useSealedSt5,
      _unstable_useSealedSt6 = _unstable_useSealedSt.unstable_preventOverflow,
      preventOverflow = _unstable_useSealedSt6 === void 0 ? true : _unstable_useSealedSt6,
      _unstable_useSealedSt7 = _unstable_useSealedSt.unstable_boundariesElement,
      boundariesElement = _unstable_useSealedSt7 === void 0 ? "scrollParent" : _unstable_useSealedSt7,
      _unstable_useSealedSt8 = _unstable_useSealedSt.unstable_fixed,
      fixed = _unstable_useSealedSt8 === void 0 ? false : _unstable_useSealedSt8,
      sealed = _objectWithoutPropertiesLoose(_unstable_useSealedSt, ["placement", "unstable_flip", "unstable_shift", "unstable_gutter", "unstable_preventOverflow", "unstable_boundariesElement", "unstable_fixed"]);

  var popper = useRef(null);
  var referenceRef = useRef(null);
  var popoverRef = useRef(null);
  var arrowRef = useRef(null);

  var _React$useState = useState(sealedPlacement),
      originalPlacement = _React$useState[0],
      place = _React$useState[1];

  var _React$useState2 = useState(sealedPlacement),
      placement = _React$useState2[0],
      setPlacement = _React$useState2[1];

  var _React$useState3 = useState({}),
      popoverStyles = _React$useState3[0],
      setPopoverStyles = _React$useState3[1];

  var _React$useState4 = useState({}),
      arrowStyles = _React$useState4[0],
      setArrowStyles = _React$useState4[1];

  var dialog = useDialogState(sealed);
  useLayoutEffect(function () {
    if (referenceRef.current && popoverRef.current) {
      popper.current = new Popper(referenceRef.current, popoverRef.current, {
        placement: originalPlacement,
        eventsEnabled: false,
        positionFixed: fixed,
        modifiers: {
          applyStyle: {
            enabled: false
          },
          flip: {
            enabled: flip,
            padding: 16
          },
          shift: {
            enabled: shift
          },
          offset: {
            enabled: shift,
            offset: "0, " + gutter
          },
          preventOverflow: {
            enabled: preventOverflow,
            boundariesElement: boundariesElement
          },
          arrow: arrowRef.current ? {
            enabled: true,
            element: arrowRef.current
          } : undefined,
          updateStateModifier: {
            order: 900,
            // TODO: https://github.com/facebook/react/pull/14853
            enabled: process.env.NODE_ENV !== "test",
            fn: function fn(data) {
              setPlacement(data.placement);
              setPopoverStyles(data.styles);
              setArrowStyles(data.arrowStyles);
              return data;
            }
          }
        }
      });
    }

    return function () {
      if (popper.current) {
        popper.current.destroy();
      }
    };
  }, [originalPlacement, flip, shift, gutter]);
  useLayoutEffect(function () {
    if (!popper.current) return;

    if (dialog.visible) {
      popper.current.enableEventListeners();
    } else {
      popper.current.disableEventListeners();
    }

    popper.current.update();
  }, [dialog.visible]);
  return _objectSpread({}, dialog, {
    unstable_referenceRef: referenceRef,
    unstable_popoverRef: popoverRef,
    unstable_arrowRef: arrowRef,
    unstable_popoverStyles: popoverStyles,
    unstable_arrowStyles: arrowStyles,
    unstable_originalPlacement: originalPlacement,
    placement: placement,
    place: useCallback(place, [])
  });
}
var keys = [].concat(useDialogState.__keys, ["unstable_referenceRef", "unstable_popoverRef", "unstable_arrowRef", "unstable_popoverStyles", "unstable_arrowStyles", "unstable_originalPlacement", "placement", "place"]);
usePopoverState.__keys = keys;

export { usePopoverState };
