import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { a as warning } from '../chunk-e555b6ea.js';
import '../chunk-b4d83ecc.js';
import '../chunk-96f01ae3.js';
import '../Rover/RoverState.js';
import '../Rover/Rover.js';
import { useRadioState } from './RadioState.js';

var useRadioGroup = unstable_createHook({
  name: "RadioGroup",
  compose: useBox,
  useState: useRadioState,
  useProps: function useProps(_, htmlProps) {
    return unstable_mergeProps({
      role: "radiogroup"
    }, htmlProps);
  }
});
var RadioGroup = unstable_createComponent({
  as: "fieldset",
  useHook: useRadioGroup,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/radio", "RadioGroup") : void 0;
    return unstable_useCreateElement(type, props, children);
  }
});

export { RadioGroup };
