import 'react';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { b as _objectWithoutPropertiesLoose, a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';

var useSeparator = unstable_createHook({
  name: "Separator",
  compose: useBox,
  keys: ["orientation"],
  useOptions: function useOptions(_ref) {
    var _ref$orientation = _ref.orientation,
        orientation = _ref$orientation === void 0 ? "vertical" : _ref$orientation,
        options = _objectWithoutPropertiesLoose(_ref, ["orientation"]);

    return _objectSpread({
      orientation: orientation
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var flipMap = {
      horizontal: "vertical",
      vertical: "horizontal"
    };
    return unstable_mergeProps({
      role: "separator",
      "aria-orientation": options.orientation ? flipMap[options.orientation] : undefined
    }, htmlProps);
  }
});
var Separator = unstable_createComponent({
  as: "hr",
  useHook: useSeparator
});

export { Separator, useSeparator };
