import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';
import { a as warning } from '../chunk-e555b6ea.js';
import '../Rover/RoverState.js';
import { useTabState } from './TabState.js';

var useTabList = unstable_createHook({
  name: "TabList",
  compose: useBox,
  useState: useTabState,
  useProps: function useProps(options, htmlProps) {
    return unstable_mergeProps({
      role: "tablist",
      "aria-orientation": options.orientation
    }, htmlProps);
  }
});
var TabList = unstable_createComponent({
  as: "div",
  useHook: useTabList,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/tab", "TabList") : void 0;
    return unstable_useCreateElement(type, props, children);
  }
});

export { TabList, useTabList };
