import 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import { useHidden } from '../Hidden/Hidden.js';
import '../Rover/RoverState.js';
import { b as getTabPanelId, a as getTabId } from '../chunk-ddf73afb.js';
import { useTabState } from './TabState.js';

var useTabPanel = unstable_createHook({
  name: "TabPanel",
  compose: useHidden,
  useState: useTabState,
  keys: ["stopId"],
  useOptions: function useOptions(options) {
    return _objectSpread({
      visible: options.selectedId === options.stopId
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    return unstable_mergeProps({
      role: "tabpanel",
      tabIndex: 0,
      id: getTabPanelId(options.stopId, options.unstable_baseId),
      "aria-labelledby": getTabId(options.stopId, options.unstable_baseId)
    }, htmlProps);
  }
});
var TabPanel = unstable_createComponent({
  as: "div",
  useHook: useTabPanel
});

export { TabPanel, useTabPanel };
