import { useCallback, createElement } from 'react';
import '../utils/useSealedState.js';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import { a as _objectSpread } from '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../Box/Box.js';
import 'react-dom';
import { Portal } from '../Portal/Portal.js';
import '../Hidden/HiddenState.js';
import { useHidden } from '../Hidden/Hidden.js';
import '../Dialog/DialogState.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { useTooltipState } from './TooltipState.js';

var useTooltip = unstable_createHook({
  name: "Tooltip",
  compose: useHidden,
  useState: useTooltipState,
  useProps: function useProps(options, htmlProps) {
    var wrap = useCallback(function (children) {
      return createElement(Portal, null, children);
    }, []);
    return unstable_mergeProps({
      role: "tooltip",
      ref: options.unstable_popoverRef,
      style: _objectSpread({}, options.unstable_popoverStyles, {
        pointerEvents: "none",
        zIndex: 999
      }),
      unstable_wrap: wrap
    }, htmlProps);
  }
});
var Tooltip = unstable_createComponent({
  as: "div",
  useHook: useTooltip
});

export { Tooltip, useTooltip };
