import 'react';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { unstable_mergeProps } from '../utils/mergeProps.js';
import '../chunk-adf96f9e.js';
import '../system/useToken.js';
import '../system/useOptions.js';
import '../system/useProps.js';
import '../chunk-2f16e450.js';
import { unstable_createHook } from '../utils/createHook.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import { useBox } from '../Box/Box.js';

var useVisuallyHidden = unstable_createHook({
  name: "VisuallyHidden",
  compose: useBox,
  useProps: function useProps(_, htmlProps) {
    return unstable_mergeProps({
      style: {
        border: 0,
        clip: "rect(0 0 0 0)",
        height: "1px",
        margin: "-1px",
        overflow: "hidden",
        padding: 0,
        position: "absolute",
        whiteSpace: "nowrap",
        width: "1px"
      }
    }, htmlProps);
  }
});
var VisuallyHidden = unstable_createComponent({
  as: "span",
  useHook: useVisuallyHidden
});

export { VisuallyHidden, useVisuallyHidden };
