'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../Hidden/HiddenState.js');
var Hidden = require('../Hidden/Hidden.js');
var DialogState = require('./DialogState.js');

var useDialogBackdrop = createHook.unstable_createHook({
  name: "DialogBackdrop",
  compose: Hidden.useHidden,
  useState: DialogState.useDialogState,
  useProps: function useProps(_, htmlProps) {
    return mergeProps.unstable_mergeProps({
      id: undefined,
      role: "presentation",
      style: {
        position: "fixed",
        top: 0,
        right: 0,
        bottom: 0,
        left: 0,
        zIndex: 998
      }
    }, htmlProps);
  }
});
var DialogBackdrop = createComponent.unstable_createComponent({
  as: "div",
  useHook: useDialogBackdrop
});

exports.DialogBackdrop = DialogBackdrop;
exports.useDialogBackdrop = useDialogBackdrop;
