'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
var useOptions = require('../system/useOptions.js');
var useProps = require('../system/useProps.js');
require('../chunk-c06eec31.js');
require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
var Tabbable = require('../Tabbable/Tabbable.js');
require('../chunk-5a603fe6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
var getIn = require('./utils/getIn.js');
require('./utils/setIn.js');
var __chunk_9 = require('../chunk-0ecca8fe.js');
var __chunk_10 = require('../chunk-46c7f4d8.js');
var __chunk_11 = require('../chunk-044cfb41.js');
var __chunk_12 = require('../chunk-acd59aa4.js');

var defaultClickKeys = [];
function unstable_useFormInput(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("FormInput", options, htmlProps);
  htmlProps = mergeProps.unstable_mergeProps({
    id: __chunk_10.getInputId(options.name, options.baseId),
    name: __chunk_9.formatInputName(options.name),
    value: getIn.unstable_getIn(options.values, options.name, ""),
    onChange: function onChange(event) {
      return options.update(options.name, event.target.value);
    },
    onBlur: function onBlur() {
      return options.blur(options.name);
    },
    "aria-describedby": __chunk_12.getMessageId(options.name, options.baseId),
    "aria-labelledby": __chunk_11.getLabelId(options.name, options.baseId),
    "aria-invalid": __chunk_12.shouldShowError(options, options.name)
  }, htmlProps);
  htmlProps = useProps.unstable_useProps("FormInput", options, htmlProps);
  htmlProps = Tabbable.useTabbable(__chunk_3._objectSpread({}, options, {
    unstable_clickKeys: defaultClickKeys
  }), htmlProps);
  return htmlProps;
}
var keys = [].concat(Tabbable.useTabbable.__keys, FormState.unstable_useFormState.__keys, ["name"]);
unstable_useFormInput.__keys = keys;
var unstable_FormInput = createComponent.unstable_createComponent({
  as: "input",
  useHook: unstable_useFormInput
});

exports.unstable_FormInput = unstable_FormInput;
exports.unstable_useFormInput = unstable_useFormInput;
