'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
var useOptions = require('../system/useOptions.js');
var useProps = require('../system/useProps.js');
require('../chunk-c06eec31.js');
require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
require('./utils/getIn.js');
require('./utils/setIn.js');
require('../chunk-0ecca8fe.js');
require('../chunk-46c7f4d8.js');
require('../chunk-044cfb41.js');
require('../chunk-acd59aa4.js');
require('../Group/Group.js');
var FormGroup = require('./FormGroup.js');
var RoverState = require('../Rover/RoverState.js');

var FormRadioGroupContext = React.createContext(null);
function unstable_useFormRadioGroup(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var rover = RoverState.useRoverState({
    loop: true
  });
  var providerValue = React.useMemo(function () {
    return rover;
  }, [rover.stops, rover.currentId, rover.unstable_pastId]);
  options = useOptions.unstable_useOptions("FormRadioGroup", options, htmlProps);
  htmlProps = mergeProps.unstable_mergeProps({
    role: "radiogroup",
    unstable_wrap: function unstable_wrap(children) {
      return React.createElement(FormRadioGroupContext.Provider, {
        value: providerValue
      }, children);
    }
  }, htmlProps);
  htmlProps = useProps.unstable_useProps("FormRadioGroup", options, htmlProps);
  htmlProps = FormGroup.unstable_useFormGroup(options, htmlProps);
  return htmlProps;
}
var keys = [].concat(FormGroup.unstable_useFormGroup.__keys, FormState.unstable_useFormState.__keys, ["name"]);
unstable_useFormRadioGroup.__keys = keys;
var unstable_FormRadioGroup = createComponent.unstable_createComponent({
  as: "fieldset",
  useHook: unstable_useFormRadioGroup
});

exports.FormRadioGroupContext = FormRadioGroupContext;
exports.unstable_FormRadioGroup = unstable_FormRadioGroup;
exports.unstable_useFormRadioGroup = unstable_useFormRadioGroup;
