'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
var Box = require('../Box/Box.js');
var HiddenState = require('./HiddenState.js');

var useHidden = createHook.unstable_createHook({
  name: "Hidden",
  compose: Box.useBox,
  useState: HiddenState.useHiddenState,
  keys: ["unstable_animated"],
  useProps: function useProps(options, htmlProps) {
    var _React$useState = React.useState(options.visible),
        delayedVisible = _React$useState[0],
        setDelayedVisible = _React$useState[1];

    React.useEffect(function () {
      if (options.unstable_animated && options.visible) {
        setDelayedVisible(options.visible);
      }
    }, [options.visible, options.unstable_animated]);
    var onTransitionEnd = React.useCallback(function () {
      if (options.unstable_animated && !options.visible) {
        setDelayedVisible(options.visible);
      }
    }, [options.visible, options.unstable_animated]); // delays hiding

    var hidden = options.unstable_animated ? options.visible ? false : !delayedVisible : !options.visible; // delays showing

    var shouldAddHiddenClass = options.unstable_animated ? options.visible ? !delayedVisible : true : !options.visible;
    return mergeProps.unstable_mergeProps({
      role: "region",
      id: options.unstable_hiddenId,
      className: shouldAddHiddenClass ? "hidden" : undefined,
      hidden: hidden,
      onTransitionEnd: onTransitionEnd
    }, htmlProps);
  }
});
var Hidden = createComponent.unstable_createComponent({
  as: "div",
  useHook: useHidden
});

exports.Hidden = Hidden;
exports.useHidden = useHidden;
