'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useSealedState = require('../utils/useSealedState.js');
var useId = require('../utils/useId.js');

function useHiddenState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _unstable_useSealedSt = useSealedState.unstable_useSealedState(initialState),
      _unstable_useSealedSt2 = _unstable_useSealedSt.unstable_hiddenId,
      hiddenId = _unstable_useSealedSt2 === void 0 ? useId.unstable_useId("hidden-") : _unstable_useSealedSt2,
      _unstable_useSealedSt3 = _unstable_useSealedSt.visible,
      sealedVisible = _unstable_useSealedSt3 === void 0 ? false : _unstable_useSealedSt3;

  var _React$useState = React.useState(sealedVisible),
      visible = _React$useState[0],
      setVisible = _React$useState[1];

  var show = React.useCallback(function () {
    return setVisible(true);
  }, []);
  var hide = React.useCallback(function () {
    return setVisible(false);
  }, []);
  var toggle = React.useCallback(function () {
    return setVisible(function (v) {
      return !v;
    });
  }, []);
  return {
    unstable_hiddenId: hiddenId,
    visible: visible,
    show: show,
    hide: hide,
    toggle: toggle
  };
}
var keys = ["unstable_hiddenId", "visible", "show", "hide", "toggle"];
useHiddenState.__keys = keys;

exports.useHiddenState = useHiddenState;
