'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useSealedState = require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
require('../utils/createHook.js');
require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../chunk-498e747a.js');
var RoverState = require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('popper.js');
var PopoverState = require('../Popover/PopoverState.js');
var __chunk_15 = require('../chunk-8a7a2ea8.js');

function useMenuState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _unstable_useSealedSt = useSealedState.unstable_useSealedState(initialState),
      _unstable_useSealedSt2 = _unstable_useSealedSt.orientation,
      orientation = _unstable_useSealedSt2 === void 0 ? "vertical" : _unstable_useSealedSt2,
      _unstable_useSealedSt3 = _unstable_useSealedSt.unstable_gutter,
      initialGutter = _unstable_useSealedSt3 === void 0 ? 0 : _unstable_useSealedSt3,
      _unstable_useSealedSt4 = _unstable_useSealedSt.unstable_values,
      initialValues = _unstable_useSealedSt4 === void 0 ? {} : _unstable_useSealedSt4,
      sealed = __chunk_3._objectWithoutPropertiesLoose(_unstable_useSealedSt, ["orientation", "unstable_gutter", "unstable_values"]);

  var _React$useState = React.useState(initialValues),
      values = _React$useState[0],
      setValues = _React$useState[1];

  var parent = React.useContext(__chunk_15.MenuContext);
  var placement = sealed.placement || (parent && parent.orientation === "vertical" ? "right-start" : "bottom-start");
  var rover = RoverState.useRoverState(__chunk_3._objectSpread({}, sealed, {
    orientation: orientation
  }));
  var popover = PopoverState.usePopoverState(__chunk_3._objectSpread({}, sealed, {
    placement: placement,
    unstable_gutter: initialGutter
  }));
  React.useEffect(function () {
    if (!popover.visible) {
      rover.unstable_reset();
    }
  }, [popover.visible]);
  return __chunk_3._objectSpread({}, rover, popover, {
    unstable_values: values,
    unstable_update: React.useCallback(function (name, value) {
      setValues(function (vals) {
        var _objectSpread2;

        return __chunk_3._objectSpread({}, vals, (_objectSpread2 = {}, _objectSpread2[name] = typeof value === "function" ? value(vals) : value, _objectSpread2));
      });
    }, [])
  });
}
var keys = [].concat(RoverState.useRoverState.__keys, PopoverState.usePopoverState.__keys, ["unstable_values", "unstable_update"]);
useMenuState.__keys = keys;

exports.useMenuState = useMenuState;
