'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../chunk-d4f443f9.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('react-dom');
require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
require('../Hidden/Hidden.js');
var Dialog = require('../Dialog/Dialog.js');
require('body-scroll-lock');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

var usePopover = createHook.unstable_createHook({
  name: "Popover",
  compose: Dialog.useDialog,
  useState: PopoverState.usePopoverState,
  useOptions: function useOptions(_ref) {
    var _ref$modal = _ref.modal,
        modal = _ref$modal === void 0 ? false : _ref$modal,
        options = __chunk_3._objectWithoutPropertiesLoose(_ref, ["modal"]);

    return __chunk_3._objectSpread({
      modal: modal
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    return mergeProps.unstable_mergeProps({
      ref: options.unstable_popoverRef,
      style: options.unstable_popoverStyles
    }, htmlProps);
  }
});
var Popover = createComponent.unstable_createComponent({
  as: "div",
  useHook: usePopover,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/popover", "Popover") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.Popover = Popover;
exports.usePopover = usePopover;
