'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../Hidden/HiddenState.js');
require('../Hidden/Hidden.js');
require('../Dialog/DialogState.js');
var DialogBackdrop = require('../Dialog/DialogBackdrop.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

var usePopoverBackdrop = createHook.unstable_createHook({
  name: "PopoverBackdrop",
  compose: DialogBackdrop.useDialogBackdrop,
  useState: PopoverState.usePopoverState
});
var PopoverBackdrop = createComponent.unstable_createComponent({
  as: "div",
  useHook: usePopoverBackdrop
});

exports.PopoverBackdrop = PopoverBackdrop;
exports.usePopoverBackdrop = usePopoverBackdrop;
