'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../system/SystemProvider.js');
require('../utils/Provider.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../Hidden/HiddenDisclosure.js');
var DialogDisclosure = require('../Dialog/DialogDisclosure.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

var usePopoverDisclosure = createHook.unstable_createHook({
  name: "PopoverDisclosure",
  compose: DialogDisclosure.useDialogDisclosure,
  useState: PopoverState.usePopoverState,
  useProps: function useProps(options, htmlProps) {
    return mergeProps.unstable_mergeProps({
      ref: options.unstable_referenceRef
    }, htmlProps);
  }
});
var PopoverDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: usePopoverDisclosure
});

exports.PopoverDisclosure = PopoverDisclosure;
exports.usePopoverDisclosure = usePopoverDisclosure;
