'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../chunk-498e747a.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
var RadioState = require('./RadioState.js');

var defaultClickKeys = [" "];
var useRadio = createHook.unstable_createHook({
  name: "Radio",
  compose: Rover.useRover,
  useState: RadioState.useRadioState,
  keys: ["value", "checked"],
  useProps: function useProps(options, htmlProps) {
    var checked = typeof options.checked !== "undefined" ? options.checked : options.state === options.value;
    var onChange = React.useCallback(function () {
      if (options.disabled || !options.setState) return;
      options.setState(options.value);
    }, [options.disabled, options.setState, options.value]);
    var onClick = React.useCallback(function (event) {
      if (event.target instanceof HTMLInputElement) return;
      htmlProps.onChange(event);
    }, [htmlProps.onChange]);
    htmlProps = mergeProps.unstable_mergeProps({
      checked: checked,
      "aria-checked": checked,
      value: options.value,
      role: "radio",
      type: "radio",
      onChange: onChange,
      onClick: onClick
    }, htmlProps);
    return htmlProps;
  },
  useCompose: function useCompose(options, htmlProps) {
    return Rover.useRover(__chunk_3._objectSpread({}, options, {
      unstable_clickKeys: defaultClickKeys
    }), htmlProps);
  }
});
var Radio = createComponent.unstable_createComponent({
  as: "input",
  useHook: useRadio
});

exports.Radio = Radio;
exports.useRadio = useRadio;
