'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
var Box = require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../chunk-498e747a.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
var RadioState = require('./RadioState.js');

var useRadioGroup = createHook.unstable_createHook({
  name: "RadioGroup",
  compose: Box.useBox,
  useState: RadioState.useRadioState,
  useProps: function useProps(_, htmlProps) {
    return mergeProps.unstable_mergeProps({
      role: "radiogroup"
    }, htmlProps);
  }
});
var RadioGroup = createComponent.unstable_createComponent({
  as: "fieldset",
  useHook: useRadioGroup,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/radio", "RadioGroup") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.RadioGroup = RadioGroup;
