'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
var Box = require('../Box/Box.js');

var useSeparator = createHook.unstable_createHook({
  name: "Separator",
  compose: Box.useBox,
  keys: ["orientation"],
  useOptions: function useOptions(_ref) {
    var _ref$orientation = _ref.orientation,
        orientation = _ref$orientation === void 0 ? "vertical" : _ref$orientation,
        options = __chunk_3._objectWithoutPropertiesLoose(_ref, ["orientation"]);

    return __chunk_3._objectSpread({
      orientation: orientation
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var flipMap = {
      horizontal: "vertical",
      vertical: "horizontal"
    };
    return mergeProps.unstable_mergeProps({
      role: "separator",
      "aria-orientation": options.orientation ? flipMap[options.orientation] : undefined
    }, htmlProps);
  }
});
var Separator = createComponent.unstable_createComponent({
  as: "hr",
  useHook: useSeparator
});

exports.Separator = Separator;
exports.useSeparator = useSeparator;
