'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../chunk-498e747a.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
var __chunk_16 = require('../chunk-8078ee09.js');
var TabState = require('./TabState.js');

var useTab = createHook.unstable_createHook({
  name: "Tab",
  compose: Rover.useRover,
  useState: TabState.useTabState,
  useOptions: function useOptions(_ref) {
    var _ref$focusable = _ref.focusable,
        focusable = _ref$focusable === void 0 ? true : _ref$focusable,
        options = __chunk_3._objectWithoutPropertiesLoose(_ref, ["focusable"]);

    return __chunk_3._objectSpread({
      focusable: focusable
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var selected = options.selectedId === options.stopId;
    var onClick = React.useCallback(function () {
      if (!options.disabled && !selected) {
        options.select(options.stopId);
      }
    }, [options.disabled, selected, options.select, options.stopId]);
    var onFocus = React.useCallback(function () {
      if (!options.disabled && !options.manual && !selected) {
        options.select(options.stopId);
      }
    }, [options.disabled, options.manual, selected, options.select, options.stopId]);
    return mergeProps.unstable_mergeProps({
      role: "tab",
      id: __chunk_16.getTabId(options.stopId, options.unstable_baseId),
      "aria-selected": selected,
      "aria-controls": __chunk_16.getTabPanelId(options.stopId, options.unstable_baseId),
      onClick: onClick,
      onFocus: onFocus
    }, htmlProps);
  }
});
var Tab = createComponent.unstable_createComponent({
  as: "button",
  useHook: useTab
});

exports.Tab = Tab;
exports.useTab = useTab;
