'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
var Box = require('../Box/Box.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('../Rover/RoverState.js');
var TabState = require('./TabState.js');

var useTabList = createHook.unstable_createHook({
  name: "TabList",
  compose: Box.useBox,
  useState: TabState.useTabState,
  useProps: function useProps(options, htmlProps) {
    return mergeProps.unstable_mergeProps({
      role: "tablist",
      "aria-orientation": options.orientation
    }, htmlProps);
  }
});
var TabList = createComponent.unstable_createComponent({
  as: "div",
  useHook: useTabList,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props. See https://reakit.io/docs/tab", "TabList") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.TabList = TabList;
exports.useTabList = useTabList;
