'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useSealedState.js');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
require('../Box/Box.js');
require('react-dom');
var Portal = require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
var Hidden = require('../Hidden/Hidden.js');
require('../Dialog/DialogState.js');
require('popper.js');
require('../Popover/PopoverState.js');
var TooltipState = require('./TooltipState.js');

var useTooltip = createHook.unstable_createHook({
  name: "Tooltip",
  compose: Hidden.useHidden,
  useState: TooltipState.useTooltipState,
  useProps: function useProps(options, htmlProps) {
    var wrap = React.useCallback(function (children) {
      return React.createElement(Portal.Portal, null, children);
    }, []);
    return mergeProps.unstable_mergeProps({
      role: "tooltip",
      ref: options.unstable_popoverRef,
      style: __chunk_3._objectSpread({}, options.unstable_popoverStyles, {
        pointerEvents: "none",
        zIndex: 999
      }),
      unstable_wrap: wrap
    }, htmlProps);
  }
});
var Tooltip = createComponent.unstable_createComponent({
  as: "div",
  useHook: useTooltip
});

exports.Tooltip = Tooltip;
exports.useTooltip = useTooltip;
