'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
require('../system/useToken.js');
require('../system/useOptions.js');
require('../system/useProps.js');
require('../chunk-c06eec31.js');
var createHook = require('../utils/createHook.js');
var createComponent = require('../utils/createComponent.js');
var Box = require('../Box/Box.js');

var useVisuallyHidden = createHook.unstable_createHook({
  name: "VisuallyHidden",
  compose: Box.useBox,
  useProps: function useProps(_, htmlProps) {
    return mergeProps.unstable_mergeProps({
      style: {
        border: 0,
        clip: "rect(0 0 0 0)",
        height: "1px",
        margin: "-1px",
        overflow: "hidden",
        padding: 0,
        position: "absolute",
        whiteSpace: "nowrap",
        width: "1px"
      }
    }, htmlProps);
  }
});
var VisuallyHidden = createComponent.unstable_createComponent({
  as: "span",
  useHook: useVisuallyHidden
});

exports.VisuallyHidden = VisuallyHidden;
exports.useVisuallyHidden = useVisuallyHidden;
