/// <reference types="react" />
import { BoxOptions, BoxHTMLProps } from "../Box/Box";
import { PropsWithAs } from "../__utils/types";
import { unstable_FormStateReturn } from "./FormState";
import { DeepPath } from "./__utils/types";
export declare type unstable_FormMessageOptions<V, P extends DeepPath<V, P>> = BoxOptions & Pick<unstable_FormStateReturn<V>, "baseId" | "touched" | "errors" | "messages"> & {
    /**
     * FormInput's name as in form values.
     */
    name: P;
};
export declare type unstable_FormMessageHTMLProps = BoxHTMLProps;
export declare type unstable_FormMessageProps<V, P extends DeepPath<V, P>> = unstable_FormMessageOptions<V, P> & unstable_FormMessageHTMLProps;
export declare function unstable_useFormMessage<V, P extends DeepPath<V, P>>(options: unstable_FormMessageOptions<V, P>, htmlProps?: unstable_FormMessageHTMLProps): BoxHTMLProps;
export declare namespace unstable_useFormMessage {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "name" | "submit" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormMessage: <V, P extends DeepPath<V, P>, T extends import("react").ElementType<any> = "div">(props: PropsWithAs<unstable_FormMessageOptions<V, P>, T>) => JSX.Element;
