/// <reference types="react" />
import { ButtonOptions, ButtonHTMLProps } from "../Button/Button";
import { ArrayValue, PropsWithAs } from "../__utils/types";
import { unstable_FormStateReturn } from "./FormState";
import { DeepPath, DeepPathValue } from "./__utils/types";
export declare type unstable_FormPushButtonOptions<V, P extends DeepPath<V, P>> = ButtonOptions & Pick<unstable_FormStateReturn<V>, "baseId" | "values" | "push"> & {
    /**
     * FormInput's name as in form values. This should point to array value.
     */
    name: P;
    /**
     * The value that is going to be pushed to `form.values[name]`.
     */
    value: ArrayValue<DeepPathValue<V, P>>;
};
export declare type unstable_FormPushButtonHTMLProps = ButtonHTMLProps;
export declare type unstable_FormPushButtonProps<V, P extends DeepPath<V, P>> = unstable_FormPushButtonOptions<V, P> & unstable_FormPushButtonHTMLProps;
export declare function unstable_useFormPushButton<V, P extends DeepPath<V, P>>(options: unstable_FormPushButtonOptions<V, P>, htmlProps?: unstable_FormPushButtonHTMLProps): ButtonHTMLProps;
export declare namespace unstable_useFormPushButton {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "disabled" | "focusable" | "unstable_clickKeys" | "value" | "name" | "submit" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormPushButton: <V, P extends DeepPath<V, P>, T extends import("react").ElementType<any> = "button">(props: PropsWithAs<unstable_FormPushButtonOptions<V, P>, T>) => JSX.Element;
