/// <reference types="react" />
import { ButtonOptions, ButtonHTMLProps } from "../Button/Button";
import { PropsWithAs } from "../__utils/types";
import { unstable_FormStateReturn } from "./FormState";
import { DeepPath } from "./__utils/types";
export declare type unstable_FormRemoveButtonOptions<V, P extends DeepPath<V, P>> = ButtonOptions & Pick<unstable_FormStateReturn<V>, "baseId" | "values" | "remove"> & {
    /**
     * FormInput's name as in form values. This should point to array value.
     */
    name: P;
    /**
     * The index in `form.values[name]` that will be removed.
     */
    index: number;
};
export declare type unstable_FormRemoveButtonHTMLProps = ButtonHTMLProps;
export declare type unstable_FormRemoveButtonProps<V, P extends DeepPath<V, P>> = unstable_FormRemoveButtonOptions<V, P> & unstable_FormRemoveButtonHTMLProps;
export declare function unstable_useFormRemoveButton<V, P extends DeepPath<V, P>>(options: unstable_FormRemoveButtonOptions<V, P>, htmlProps?: unstable_FormRemoveButtonHTMLProps): ButtonHTMLProps;
export declare namespace unstable_useFormRemoveButton {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "disabled" | "focusable" | "unstable_clickKeys" | "name" | "submit" | "reset" | "index" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormRemoveButton: <V, P extends DeepPath<V, P>, T extends import("react").ElementType<any> = "button">(props: PropsWithAs<unstable_FormRemoveButtonOptions<V, P>, T>) => JSX.Element;
