import * as React from "react";
import { BoxOptions, BoxHTMLProps } from "../Box/Box";
import { HiddenStateReturn } from "./HiddenState";
export declare type HiddenOptions = BoxOptions & Pick<Partial<HiddenStateReturn>, "unstable_hiddenId" | "visible"> & {
    /**
     * If `true`, the hidden element attributes will be set in different
     * timings to enable CSS transitions. This means that you can safely use the `.hidden` selector in the CSS to
     * create transitions.
     *  - When it becomes visible, immediatelly remove the `hidden` attribute,
     * then add the `hidden` class.
     *  - When it becomes hidden, immediatelly remove the `hidden` class, then
     * add the `hidden` attribute.
     */
    unstable_animated?: boolean;
};
export declare type HiddenHTMLProps = BoxHTMLProps;
export declare type HiddenProps = HiddenOptions & HiddenHTMLProps;
export declare const useHidden: {
    (options?: HiddenOptions | undefined, htmlProps?: BoxHTMLProps | undefined): BoxHTMLProps;
    __keys: readonly any[];
    __propsAreEqual?: ((prev: BoxOptions & Pick<Partial<HiddenStateReturn>, "visible" | "unstable_hiddenId"> & {
        /**
         * If `true`, the hidden element attributes will be set in different
         * timings to enable CSS transitions. This means that you can safely use the `.hidden` selector in the CSS to
         * create transitions.
         *  - When it becomes visible, immediatelly remove the `hidden` attribute,
         * then add the `hidden` class.
         *  - When it becomes hidden, immediatelly remove the `hidden` class, then
         * add the `hidden` attribute.
         */
        unstable_animated?: boolean | undefined;
    } & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        unstable_wrap?: ((children: React.ReactNode) => JSX.Element) | undefined;
    }, next: BoxOptions & Pick<Partial<HiddenStateReturn>, "visible" | "unstable_hiddenId"> & {
        /**
         * If `true`, the hidden element attributes will be set in different
         * timings to enable CSS transitions. This means that you can safely use the `.hidden` selector in the CSS to
         * create transitions.
         *  - When it becomes visible, immediatelly remove the `hidden` attribute,
         * then add the `hidden` class.
         *  - When it becomes hidden, immediatelly remove the `hidden` class, then
         * add the `hidden` attribute.
         */
        unstable_animated?: boolean | undefined;
    } & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        unstable_wrap?: ((children: React.ReactNode) => JSX.Element) | undefined;
    }) => boolean) | undefined;
};
export declare const Hidden: import("../utils/createComponent").Component<"div", HiddenOptions>;
