import { unstable_SealedInitialState } from "../utils/useSealedState";
import { PopoverState, PopoverActions, PopoverInitialState } from "../Popover/PopoverState";
import { RoverState, RoverActions, RoverInitialState } from "../Rover";
export declare type MenuState = RoverState & PopoverState & {
    /**
     * Stores the values of radios and checkboxes within the menu.
     */
    unstable_values: Record<string, any>;
};
export declare type MenuActions = RoverActions & PopoverActions & {
    /**
     * Updates checkboxes and radios values within the menu.
     */
    unstable_update: (name: string, value?: any) => void;
};
export declare type MenuInitialState = RoverInitialState & PopoverInitialState & Partial<Pick<MenuState, "unstable_values">>;
export declare type MenuStateReturn = MenuState & MenuActions;
export declare function useMenuState(initialState?: unstable_SealedInitialState<MenuInitialState>): MenuStateReturn;
export declare namespace useMenuState {
    var __keys: ("move" | "visible" | "unstable_referenceRef" | "unstable_hiddenId" | "show" | "hide" | "unstable_popoverRef" | "unstable_arrowRef" | "unstable_popoverStyles" | "unstable_arrowStyles" | "unstable_originalPlacement" | "placement" | "toggle" | "place" | "orientation" | "stops" | "currentId" | "unstable_pastId" | "loop" | "register" | "unregister" | "next" | "previous" | "first" | "last" | "unstable_reset" | "unstable_orientate" | "unstable_values" | "unstable_update")[];
}
