/// <reference types="react" />
import { BoxOptions, BoxHTMLProps } from "../Box/Box";
export declare type SeparatorOptions = BoxOptions & {
    /**
     * Separator's context orientation.
     * The actual separator's orientation will be flipped based on this prop.
     * So a `"vertical"` orientation means that the separator will have a
     * `"horizontal"` orientation.
     */
    orientation?: "horizontal" | "vertical";
};
export declare type SeparatorHTMLProps = BoxHTMLProps;
export declare type SeparatorProps = SeparatorOptions & SeparatorHTMLProps;
export declare const useSeparator: {
    (options?: SeparatorOptions | undefined, htmlProps?: BoxHTMLProps | undefined): BoxHTMLProps;
    __keys: readonly any[];
    __propsAreEqual?: ((prev: BoxOptions & {
        /**
         * Separator's context orientation.
         * The actual separator's orientation will be flipped based on this prop.
         * So a `"vertical"` orientation means that the separator will have a
         * `"horizontal"` orientation.
         */
        orientation?: "horizontal" | "vertical" | undefined;
    } & import("react").HTMLAttributes<any> & import("react").RefAttributes<any> & {
        unstable_wrap?: ((children: import("react").ReactNode) => JSX.Element) | undefined;
    }, next: BoxOptions & {
        /**
         * Separator's context orientation.
         * The actual separator's orientation will be flipped based on this prop.
         * So a `"vertical"` orientation means that the separator will have a
         * `"horizontal"` orientation.
         */
        orientation?: "horizontal" | "vertical" | undefined;
    } & import("react").HTMLAttributes<any> & import("react").RefAttributes<any> & {
        unstable_wrap?: ((children: import("react").ReactNode) => JSX.Element) | undefined;
    }) => boolean) | undefined;
};
export declare const Separator: import("../utils/createComponent").Component<"hr", SeparatorOptions>;
