import { unstable_SealedInitialState } from "../utils/useSealedState";
import { RoverState, RoverActions } from "../Rover/RoverState";
export declare type TabState = RoverState & {
    /**
     * An ID that will serve as a base for the tab elements.
     * @private
     */
    unstable_baseId: string;
    /**
     * The current selected tab's `stopId`.
     */
    selectedId: RoverState["currentId"];
    /**
     * Whether the tab selection should be manual.
     */
    manual: boolean;
};
export declare type TabActions = RoverActions & {
    /**
     * Selects a tab by its `stopId`.
     */
    select: (id: TabState["selectedId"]) => void;
};
export declare type TabInitialState = Partial<TabState>;
export declare type TabStateReturn = TabState & TabActions;
export declare function useTabState(initialState?: unstable_SealedInitialState<TabInitialState>): TabStateReturn;
export declare namespace useTabState {
    var __keys: ("select" | "move" | "orientation" | "stops" | "currentId" | "unstable_pastId" | "loop" | "register" | "unregister" | "next" | "previous" | "first" | "last" | "unstable_reset" | "unstable_orientate" | "unstable_baseId" | "selectedId" | "manual")[];
}
