/// <reference types="react" />
import { As, PropsWithAs } from "../__utils/types";
import { BoxHTMLProps } from "../Box/Box";
import { unstable_useCreateElement as defaultUseCreateElement } from "./useCreateElement";
declare type Hook<O> = {
    (options?: O, props?: BoxHTMLProps): BoxHTMLProps;
    __keys?: ReadonlyArray<any>;
    __propsAreEqual?: (prev: O, next: O) => boolean;
};
declare type Options<T extends As, O> = {
    as: T;
    useHook?: Hook<O>;
    keys?: ReadonlyArray<any>;
    propsAreEqual?: (prev: O, next: O) => boolean;
    useCreateElement?: typeof defaultUseCreateElement;
};
export interface Component<T extends As, O> {
    <TT extends As>(props: PropsWithAs<O, TT> & {
        as: TT;
    }): JSX.Element;
    (props: PropsWithAs<O, T>): JSX.Element;
}
export declare function unstable_createComponent<T extends As, O>({ as: type, useHook, keys, propsAreEqual, useCreateElement }: Options<T, O>): Component<T, O>;
export {};
